/*******************************************************************************
 * FoxSocialUICategoryBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSocialUICategoryBase extends Object within FoxSocialUI
    native(UI)
    config(UI);

struct native SocialCategoryTab
{
    var init string CategoryName;
    var GFxObject TabObject;

    structdefaultproperties
    {
        CategoryName=""
        TabObject=none
    }
};

var const config float WorkingDialogDisplayTime;
var transient int PendingCategoryIndex;
var transient FoxUIContextMenuWidget ContextMenu;
var protected transient string ButtonContainerPath;
var protected transient FoxUIWorkingDialogWidget WorkingDialogWidget;
var protected transient array<SocialCategoryTab> CategoryButtons;
var protected transient int SelectedCategoryIndex;
var const localized string LocStringSortPrompt;
var const localized string LocStringAddFriend;

function Initialize()
{
    SetupDelegates();
    //return;    
}

function SetupDelegates()
{
    //return;    
}

function NotifyClosing()
{
    ClearDelegates();
    CategoryButtons.Length = 0;
    //return;    
}

function ClearDelegates()
{
    //return;    
}

protected function string SocialSectionLocalize(string Key)
{
    return Outer.SocialLocalize(Key);
    //return ReturnValue;    
}

function bool CanInvitePlayer()
{
    return (Outer.Outer.Outer.GetWorldInfo().NetMode != NM_Standalone) && !Outer.Outer.Outer.GetWorldInfo().bRanked;
    //return ReturnValue;    
}

function ShowWorkingDialog(string TitleText)
{
    WorkingDialogWidget = Outer.Outer.Outer.ShowWorkingDialogWidget(class'FoxUIWorkingDialogWidget', ButtonContainerPath, "SocialWorkingDialog", 42, 107, TitleText);
    //return;    
}

function ShowTimedWorkingDialog(string TitleText, optional bool bShowTimer, optional delegate<OnClose> OnClose)
{
    bShowTimer = true;    
    WorkingDialogWidget = Outer.Outer.Outer.ShowWorkingDialogWidget(class'FoxUIWorkingDialogWidget', ButtonContainerPath, "SocialWorkingDialog", 42, 107, TitleText,, true);
    // End:0x125
    if(WorkingDialogWidget != none)
    {
        WorkingDialogWidget.DisplayTime = WorkingDialogDisplayTime;
        WorkingDialogWidget.__OnClose__Delegate = OnClose;
        WorkingDialogWidget.SetBool("showTimer", bShowTimer);
    }
    // End:0x138
    else
    {
        OnClose();
    }
    //return;    
}

function HideWorkingDialog()
{
    Outer.Outer.Outer.HideWorkingDialogWidget(WorkingDialogWidget);
    WorkingDialogWidget = none;
    //return;    
}

function PlayerDisplayInfo GetPlayerDisplayFromClan(ClanMemberDisplayInfo ToClone)
{
    local PlayerDisplayInfo Ret;

    Ret.sName = ToClone.sName;
    Ret.UniqueId = ToClone.UniqueId;
    Ret.OnlineStatus = ToClone.OnlineStatus;
    Ret.ConnectString = ToClone.ConnectString;
    Ret.RoomId = ToClone.RoomId;
    Ret.bPlayGoAvailable = ToClone.bPlayGoAvailable;
    Ret.Password = ToClone.Password;
    Ret.MapContext = ToClone.MapContext;
    Ret.GameType = ToClone.GameType;
    Ret.bInvitedYou = ToClone.bInvitedYou;
    return Ret;
    //return ReturnValue;    
}

function PlayerDisplayInfo GetPlayerDisplayFromFriend(FriendDisplayInfo ToClone)
{
    local PlayerDisplayInfo Ret;

    Ret.sName = ToClone.sName;
    Ret.UniqueId = ToClone.UniqueId;
    Ret.OnlineStatus = ToClone.OnlineStatus;
    Ret.ConnectString = ToClone.ConnectString;
    Ret.RoomId = ToClone.RoomId;
    Ret.bPlayGoAvailable = ToClone.bPlayGoAvailable;
    Ret.Password = ToClone.Password;
    Ret.MapContext = ToClone.MapContext;
    Ret.GameType = ToClone.GameType;
    Ret.bInvitedYou = ToClone.bInvitedYou;
    return Ret;
    //return ReturnValue;    
}

function PlayerDisplayInfo GetPlayerDisplayFromParty(PartyDisplayInfo ToClone)
{
    local PlayerDisplayInfo Ret;

    Ret.sName = ToClone.sName;
    Ret.UniqueId = ToClone.UniqueId;
    Ret.OnlineStatus = ToClone.OnlineStatus;
    Ret.ConnectString = ToClone.ConnectString;
    Ret.RoomId = ToClone.RoomId;
    Ret.bPlayGoAvailable = ToClone.bPlayGoAvailable;
    Ret.Password = ToClone.Password;
    Ret.MapContext = ToClone.MapContext;
    Ret.GameType = ToClone.GameType;
    Ret.bInvitedYou = ToClone.bInvitedYou;
    return Ret;
    //return ReturnValue;    
}

function InventoryButtonClicked(PlayerDisplayInfo ClickedMember, string Operation, optional bool bUsePassword)
{
    local DialogBoxProperties Props;

    switch(Operation)
    {
        // End:0x12E
        case "OnlineProfile":
            Outer.Outer.Outer.PCOwner.OnlineSub.PlayerInterfaceEx.ShowGamerCardUI(byte(Outer.Outer.Outer.GetLP().ControllerId), ClickedMember.UniqueId);
            // End:0xFC2
            break;
        // End:0x1C9
        case "SendMail":
            Outer.PendingSendMailInfo.To = ClickedMember.sName;
            Outer.RemoteSelectSocialCategory(Outer.MailCategory);
            // End:0xFC2
            break;
        // End:0x600
        case "JoinMatch":
            // End:0x576
            if(class'WorldInfo'.static.IsConsoleBuild())
            {
                // End:0x44A
                if(ClickedMember.bPlayGoAvailable || Outer.Outer.Outer.OnlineSub.GameDownloadInterface.IsGameComplete() && !Outer.Outer.Outer.OnlineSub.GameDownloadInterface.DoesGameNeedRefresh())
                {
                    // End:0x3C0
                    if(bUsePassword)
                    {
                        Outer.Outer.Outer.JoinGameByRoomId(ClickedMember.RoomId, ClickedMember.Password != "", ClickedMember.Password);
                    }
                    // End:0x447
                    else
                    {
                        Outer.Outer.Outer.JoinGameByRoomId(ClickedMember.RoomId, ClickedMember.Password != "");
                    }
                }
                // End:0x573
                else
                {
                    Props.DialogType = 1;
                    Props.bCloseOnButtonPress = true;
                    Props.TitleText = Localize("Menu", "AutoJoinErrorTitle", "FoxMenuUI");
                    Props.BodyText = Localize("Menu", "AutoJoinErrorPlayGo", "FoxMenuUI");
                    Outer.Outer.Outer.ShowDialogBox(Props);
                }
            }
            // End:0x5FD
            else
            {
                Outer.Outer.Outer.JoinGameByConnectString(ClickedMember.ConnectString, ClickedMember.Password != "");
            }
            // End:0xFC2
            break;
        // End:0xA3B
        case "SpectateMatch":
            // End:0x9B1
            if(class'WorldInfo'.static.IsConsoleBuild())
            {
                // End:0x885
                if(ClickedMember.bPlayGoAvailable || Outer.Outer.Outer.OnlineSub.GameDownloadInterface.IsGameComplete() && !Outer.Outer.Outer.OnlineSub.GameDownloadInterface.DoesGameNeedRefresh())
                {
                    // End:0x7FB
                    if(bUsePassword)
                    {
                        Outer.Outer.Outer.JoinGameByRoomId(ClickedMember.RoomId, ClickedMember.Password != "", ClickedMember.Password, true);
                    }
                    // End:0x882
                    else
                    {
                        Outer.Outer.Outer.JoinGameByRoomId(ClickedMember.RoomId, ClickedMember.Password != "",, true);
                    }
                }
                // End:0x9AE
                else
                {
                    Props.DialogType = 1;
                    Props.bCloseOnButtonPress = true;
                    Props.TitleText = Localize("Menu", "AutoJoinErrorTitle", "FoxMenuUI");
                    Props.BodyText = Localize("Menu", "AutoJoinErrorPlayGo", "FoxMenuUI");
                    Outer.Outer.Outer.ShowDialogBox(Props);
                }
            }
            // End:0xA38
            else
            {
                Outer.Outer.Outer.JoinGameByConnectString(ClickedMember.ConnectString, ClickedMember.Password != "",, true);
            }
            // End:0xFC2
            break;
        // End:0xA62
        case "AcceptInvite":
            AcceptInvite(ClickedMember);
            // End:0xFC2
            break;
        // End:0xAC5
        case "InviteParty":
            Outer.Outer.InvitePlayerToParty(ClickedMember.UniqueId);
            // End:0xFC2
            break;
        // End:0xB59
        case "InvitePartyByName":
            Outer.Outer.Outer.PartyInterface.InviteToPartyByUserName(ClickedMember.sName);
            // End:0xFC2
            break;
        // End:0xBCF
        case "AddFriend":
            Outer.Outer.Outer.ei_AddFriend(ClickedMember.sName);
            // End:0xFC2
            break;
        // End:0xC50
        case "SendGameInviteInGame":
            Outer.Outer.Outer.SendGameInviteInGame(ClickedMember.UniqueId);
            // End:0xFC2
            break;
        // End:0xCD4
        case "SendGameInviteOutOfGame":
            Outer.Outer.Outer.SendGameInviteOutOfGame(ClickedMember.UniqueId);
            // End:0xFC2
            break;
        // End:0xD4F
        case "SendGameInvite":
            Outer.Outer.Outer.SendGameInvite(ClickedMember.UniqueId);
            // End:0xFC2
            break;
        // End:0xE38
        case "Whisper":
            Outer.Outer.Outer.Chat.ReplyPlayer = ClickedMember.sName;
            Outer.Outer.Outer.Chat.SmartModeChange(5);
            // End:0xFC2
            break;
        // End:0xEB5
        case "Ignore":
            Outer.Outer.Outer.IgnorePlayer(ClickedMember.sName);
            RefreshInventoryButtons();
            // End:0xFC2
            break;
        // End:0xF34
        case "Unignore":
            Outer.Outer.Outer.UnIgnorePlayer(ClickedMember.sName);
            RefreshInventoryButtons();
            // End:0xFC2
            break;
        // End:0xFAE
        case "InviteToClan":
            Outer.Outer.Outer.InviteToClan(ClickedMember.sName);
            // End:0xFC2
            break;
        // End:0xFBC
        case "Report":
            // End:0xFC2
            break;
        // End:0xFFFF
        default:
            // End:0xFC2
            break;
    }
    //return;    
}

function AcceptInvite(PlayerDisplayInfo ClickedMember)
{
    local DialogBoxProperties Props;

    // End:0x37B
    if(class'WorldInfo'.static.IsConsoleBuild(8))
    {
        // End:0x24F
        if(ClickedMember.bPlayGoAvailable || Outer.Outer.Outer.OnlineSub.GameDownloadInterface.IsGameComplete() && !Outer.Outer.Outer.OnlineSub.GameDownloadInterface.DoesGameNeedRefresh())
        {
            // End:0x24C
            if(ClickedMember.bInvitedYou && (ClickedMember.OnlineStatus == 8) || ClickedMember.OnlineStatus == 10)
            {
                Outer.Outer.Outer.JoinGameByRoomId(ClickedMember.RoomId, ClickedMember.Password != "", ClickedMember.Password);
            }
        }
        // End:0x378
        else
        {
            Props.DialogType = 1;
            Props.bCloseOnButtonPress = true;
            Props.TitleText = Localize("Menu", "AutoJoinErrorTitle", "FoxMenuUI");
            Props.BodyText = Localize("Menu", "AutoJoinErrorPlayGo", "FoxMenuUI");
            Outer.Outer.Outer.ShowDialogBox(Props);
        }
    }
    // End:0x48F
    else
    {
        // End:0x48F
        if(ClickedMember.bInvitedYou && (ClickedMember.OnlineStatus == 8) || ClickedMember.OnlineStatus == 10)
        {
            Outer.Outer.Outer.JoinGameByConnectString(ClickedMember.ConnectString, ClickedMember.Password != "", ClickedMember.Password, false);
        }
    }
    //return;    
}

function ei_SetUpFindPlayerTab()
{
    SetUpFriendSortButtons();
    Outer.SearchTabInfoStruct.ListPath = as_AddFindList(0, 25, "ei_SearchClicked");
    as_PlaceSocialHorizLines("socialLine", 0, 508);
    //return;    
}

function ei_contextMenuClosed()
{
    Outer.Outer.Outer.ei_contextMenuClosed();
    // End:0xAA
    if(ContextMenu != none)
    {
        Outer.Outer.Outer.HideContextMenuWidget(ContextMenu);
    }
    //return;    
}

event DisplayFindPlayersTab()
{
    Outer.Outer.Outer.HideModalDialogWidget(Outer.SearchTabInfoStruct.ModalDialog);
    as_UpdateSearchList(Outer.SearchTabInfoStruct.SearchList);
    //return;    
}

function SetUpFindPlayerDelegates()
{
    Outer.Outer.Outer.FriendInterface.AddOnPlayerSearchComplete(ParseSearchList);
    //return;    
}

function ClearFindPlayerDelegates()
{
    Outer.Outer.Outer.FriendInterface.ClearOnPlayerSearchComplete(ParseSearchList);
    Outer.Outer.Outer.FriendInterface.ClearOnGetUniqueIdOfPlayerCompleteDelegate(Outer.Outer.OnGetUniqueIdOfPlayerForPartyComplete);
    //return;    
}

event ClearPlayerSearchListDelegate()
{
    Outer.Outer.Outer.FriendInterface.ClearOnPlayerSearchComplete(ParseSearchList);
    //return;    
}

// Export UFoxSocialUICategoryBase::execParseSearchList(FFrame&, void* const)
native function ParseSearchList(array<PlayerNameIdPair> ReturnedNames);

function ei_FindPlayer(string NewName)
{
    // End:0x15D
    if((Len(NewName) < 3) || InStr(NewName, " ") != -1)
    {
        Outer.Outer.Outer.Chat.UpdateCurrentLog(Outer.Outer.Outer.LocalizeChat("ChatErrorStringName"), Outer.Outer.Outer.LocalizeChat("ChatErrorStringText_BadPlayerLookUp"));
    }
    // End:0x299
    else
    {
        Outer.SearchTabInfoStruct.ModalDialog = Outer.Outer.Outer.ShowModalDialogWidget(class'FoxUIPlayerSearchModalDialogWidget', "searchingDialog", 260, 150, Localize("Social", "PlayerSearchModalLine1", "FoxMenuUI"));
        Outer.Outer.Outer.FriendInterface.SearchForPlayer(NewName);
    }
    //return;    
}

protected function ApplySocialSubCategory(string CategoryName)
{
    //return;    
}

protected function ui_addSocialSubcategory(string ButtonLabel, string ButtonToolTip, string CategoryName, string transition, optional bool InputOverride)
{
    local SocialCategoryTab Tab;
    local string ButtonPath;

    ButtonPath = as_AddSocialSubcategory(ButtonLabel, ButtonToolTip, "ei_selectSocialSubcategory", string(CategoryButtons.Length), transition, InputOverride);
    Outer.Outer.Outer.Advance(0.0);
    Tab.TabObject = Outer.Outer.Outer.GetVariableObject(ButtonPath);
    // End:0x17E
    if(Tab.TabObject != none)
    {
        Tab.CategoryName = CategoryName;
        CategoryButtons.AddItem(Tab);
    }
    //return;    
}

function ui_selectSocialSubcategory(optional int Index)
{
    // End:0x4C
    if((PendingCategoryIndex >= 0) && PendingCategoryIndex < CategoryButtons.Length)
    {
        Index = PendingCategoryIndex;
        PendingCategoryIndex = -1;
    }
    // End:0x12F
    if(((Index != SelectedCategoryIndex) && Index >= 0) && Index < CategoryButtons.Length)
    {
        Outer.Outer.Outer.Advance(0.0);
        CategoryButtons[Index].TabObject.InvokeNoParams("remoteSelect");
    }
    //return;    
}

final function ei_selectSocialSubcategory(string IndexStr)
{
    local int Index;

    Index = int(IndexStr);
    // End:0x81
    if((Index >= 0) && Index < CategoryButtons.Length)
    {
        SelectedCategoryIndex = Index;
        ApplySocialSubCategory(CategoryButtons[SelectedCategoryIndex].CategoryName);
    }
    //return;    
}

function ei_SearchClicked(int Index)
{
    Outer.SearchTabInfoStruct.ClickedIndex = Index;
    as_AddInventoryButtonContainer("inventoryButtons", 0, 516, -15, 400, 175, false);
    as_AddInventoryButtons("AddFriendLabel", "AddFriendTooltip", "ei_SearchInventoryButtonClicked", "AddFriend", "");
    as_AddInventoryButtons("AddClanLabel", "AddClanTooltip", "ei_SearchInventoryButtonClicked", "InviteToClan", "", Outer.Outer.Outer.GetClanInfo().bHasClanPermissions);
    //return;    
}

function ei_SearchInventoryButtonClicked(string Arg)
{
    local PlayerDisplayInfo ClickedMember;

    ClickedMember.sName = Outer.SearchTabInfoStruct.SearchList[Outer.SearchTabInfoStruct.ClickedIndex].sPlayerName;
    InventoryButtonClicked(ClickedMember, Arg);
    //return;    
}

function RefreshInventoryButtons()
{
    as_ClearInventoryButtons();
    ei_SearchClicked(Outer.SearchTabInfoStruct.ClickedIndex);
    //return;    
}

function as_UpdateSearchList(array<PlayerSearchData> SearchList)
{
    Outer.Outer.Outer.ActionScriptVoid(Outer.SearchTabInfoStruct.ListPath $ ".updateDataProvider");
    //return;    
}

function string InventoryLocalize(string Key)
{
    return Outer.Outer.LocalizeMenuString(Key, "Inventory");
    //return ReturnValue;    
}

function SetUpFriendSortButtons()
{
    local string DefaultButton;

    Outer.as_AddSocialButtonContainer("sortButtons", 0, 95, 3, 800, 175, false);
    DefaultButton = as_AddSocialSortButton("NameSortLabel", "NameSortTooltip", "ei_SortMembersByName");
    as_AddSocialSortDivider(93, 2, 427);
    Outer.Outer.Outer.Advance(0.0);
    Outer.Outer.Outer.as_SelectButton(DefaultButton);
    //return;    
}

function string as_AddFindList(int XPos, int YPos, string ClickInterface)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addFindList");
    //return ReturnValue;    
}

function as_PlaceSocialHorizLines(string Label, int XPos, int YPos)
{
    Outer.Outer.Outer.ActionScriptVoid("_root.placeSocialHorizLines");
    //return;    
}

function string as_AddSocialSubcategory(string Label, string ToolTip, string ClickInterface, string InterfaceArg, string TransitionType, optional bool InputOverride)
{
    Label = Outer.SocialLocalize(Label);
    ToolTip = Outer.SocialLocalize(ToolTip);
    return Outer.Outer.Outer.ActionScriptString("_root.addSocialSceneTabs");
    //return ReturnValue;    
}

function string as_AddSocialSortButton(string Label, string ToolTip, string ClickInterface)
{
    Label = Outer.SocialLocalize(Label);
    ToolTip = Outer.SocialLocalize(ToolTip);
    return Outer.Outer.Outer.ActionScriptString("_root.addSocialSortButton");
    //return ReturnValue;    
}

function as_AddInventoryButtonContainer(string ContainerName, int XPos, int YPos, int Spacing, int MaxWidth, int MaxHeight, bool VertAlign)
{
    Outer.Outer.Outer.ActionScriptVoid("_root.addInventoryButtonContainer");
    //return;    
}

function string as_AddInventoryButtons(string Label, string ToolTip, string ClickInterface, optional string ClickArg, optional string TransitionType, optional bool StartEnabled)
{
    StartEnabled = true;
    Label = Outer.SocialLocalize(Label);
    ToolTip = Outer.SocialLocalize(ToolTip);
    StartEnabled = !StartEnabled;
    return Outer.Outer.Outer.ActionScriptString("_root.addInventoryButtons");
    //return ReturnValue;    
}

function AddSocialButtonPrompt(string LocLabel, optional bool bCenterContainer, optional bool bEvenIfNotConsole)
{
    // End:0x51
    if(bEvenIfNotConsole || class'WorldInfo'.static.IsConsoleBuild())
    {
        as_addSocialButtonPrompt(LocLabel, bCenterContainer);
    }
    //return;    
}

function as_addSocialButtonPrompt(string LocLabel, optional bool bCenterContainer)
{
    LocLabel = Outer.SocialLocalize(LocLabel);
    Outer.Outer.Outer.ActionScriptVoid("_root.addSocialButtonPrompt");
    //return;    
}

function string as_AddGenericTextBox(int XPos, int YPos, string Text)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addSocialGenericTextBox");
    //return ReturnValue;    
}

function as_AddGenericButtonContainer(string instancename, int WidgetSpacing, int MaxWidth, int MaxHeight, bool AlignVert, bool InternalContainer)
{
    Outer.Outer.Outer.ActionScriptVoid("_root.addGenericButtonContainer");
    //return;    
}

function string as_AddGenericButton(string Label, string ToolTip, string ClickInterface, string Argument, string TransitionType)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addGenericButton");
    //return ReturnValue;    
}

function string as_AddSocialListInput(int XPos, int YPos, string ButtonLabel, string ClickInterface, int MaxChars, optional bool ClickToUpdate)
{
    ClickToUpdate = true;
    ButtonLabel = Outer.SocialLocalize(ButtonLabel);
    return Outer.Outer.Outer.ActionScriptString("_root.addSocialListInput");
    //return ReturnValue;    
}

function as_AddSocialSortDivider(int XPos, int YPos, int Width)
{
    Outer.Outer.Outer.ActionScriptVoid("_root.addSocialSortDivider");
    //return;    
}

function as_ShowInventoryItem(int XPos, int YPos, const BaseInventoryEntry Item)
{
    Outer.Outer.Outer.ActionScriptVoid("_root.showInventoryItem");
    //return;    
}

function string as_AddSocialInputBox(string Label, int MaxChars, string DefaultText, string InterfaceFunc, optional string ActualText)
{
    Label = Outer.SocialLocalize(Label);
    return Outer.Outer.Outer.ActionScriptString("_root.addSocialInputBox");
    //return ReturnValue;    
}

function as_updateItemListItems(array<BaseInventoryEntry> Items, string Path)
{
    Outer.Outer.Outer.ActionScriptVoid(Path $ ".updateDataProvider");
    //return;    
}

function string as_addCategoryBar(int XPos, int YPos, array<string> Categories, int StartIndex, string CallbackFunc)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addCatScroller");
    //return ReturnValue;    
}

function as_AddDestroyItemButtonContainer(string ContainerName, int XPos, int YPos, int Spacing, int MaxWidth, int MaxHeight, bool VertAlign)
{
    Outer.Outer.Outer.ActionScriptVoid("_root.addInventoryButtonContainer2");
    //return;    
}

function as_ClearInventoryButtons()
{
    Outer.Outer.Outer.ActionScriptVoid("_root.clearClanButtons");
    //return;    
}

function as_AddSocialHeader(string Label)
{
    Label = Outer.SocialLocalize(Label);
    Outer.Outer.Outer.ActionScriptString("_root.addSocialHeader");
    //return;    
}

function as_newFocusSocialSection()
{
    Outer.Outer.Outer.ActionScriptVoid("_root.newFocusSocialSection");
    //return;    
}

defaultproperties
{
    WorkingDialogDisplayTime=3.0
    PendingCategoryIndex=-1
    SelectedCategoryIndex=-1
    LocStringSortPrompt="{XboxTypeS_Y,20,20,-10} Sort"
    LocStringAddFriend="+ Add Friend"
}